<?php

/**
 * Data container describing Workpackage
 * Class is deprecated for use because uses DB access.
 * @deprecated
 */
class WorkPackageDeprecated extends Object implements iProject
{
    public $WorkPackage_ID;
    public $SAP_ID;
//    public $Project_ID;
//    public $Parent_ID;
    public $Name;
//    public $Date;

    public $level;
    private $workpackages;
    private $tasks;

    public function  __construct($WorkPackage_ID = NULL)
    {
        $this->workpackages = $this->tasks = array();
        if ($WorkPackage_ID != NULL)
        {

            // init self
            $WorkPackageDB = dibi::select('*')->from('WorkPackage')->where('[WorkPackage_ID] = %i', $WorkPackage_ID)->fetch();
            foreach(get_object_vars($this) as $name => $value){
                $this->$name = trim(@$WorkPackageDB->$name);
            }
	       $this->workpackages = $this->tasks = array();

            // init workpackages
            $WorkPackagesDB = dibi::select('*')->from('WorkPackage')->where('[Parent_ID] = %i', $this->WorkPackage_ID)->fetchAll();
            foreach($WorkPackagesDB as $WorkPackageDB){
                $WorkPackage = new WorkPackageDeprecated($WorkPackageDB->WorkPackage_ID);
                $this->workpackages[$WorkPackage->WorkPackage_ID] = $WorkPackage;
            }

            // init tasks
            $TasksDB = dibi::select('*')->from('Task')->where('[WorkPackage_ID] = %i', $this->WorkPackage_ID)->fetchAll();
            foreach($TasksDB as $TaskDB){
                $Task = new TaskDepreciated($TaskDB->Task_ID);
                $this->tasks[$Task->Task_ID] = $Task;
            }
        }

    }

    public function getChildren()
    {
        return !empty($this->workpackages) ? $this->workpackages : $this->tasks;
    }
    
    public function getPlannedLaborHours($Year, $months = array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'))
    {

        if(!(is_array($months)))
            $months = array($months);

        $sum = 0;

		if ((!($this->workpackages instanceof Traversable)) && (!is_array($this->workpackages)))
			Debugger::log('WTF:' . var_export($this->workpackages, true), Debugger::DEBUG);
        foreach($this->workpackages as $workpackage)
                $sum += $workpackage->getPlannedLaborHours($Year, $months);

        foreach($this->tasks as $task)
                $sum += $task->getPlannedLaborHours($Year, $months);

        return $sum;

    }

    public function getAssignedHours($Year, $months = array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'))
    {

        if(!(is_array($months)))
            $months = array($months);

        $sum = 0;

        foreach($this->workpackages as $workpackage)
                $sum += $workpackage->getAssignedHours($Year, $months);

        foreach($this->tasks as $task)
                $sum += $task->getAssignedHours($Year, $months);

        return $sum;

    }

    public function getActualHours($Year, $months = array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'))
    {

        if(!(is_array($months)))
            $months = array($months);

        $sum = 0;

        foreach($this->workpackages as $workpackage)
                $sum += $workpackage->getActualHours($Year, $months);

        foreach($this->tasks as $task)
                $sum += $task->getActualHours($Year, $months);

        return $sum;

    }

    public function getResources($Year)
    {

        $resources = array();

        foreach($this->workpackages as $workpackage)
            foreach($workpackage->getResources($Year) as $resource)
                array_push($resources, $resource);

        foreach($this->tasks as $task)
            foreach($task->getResources($Year) as $resource)
                array_push($resources, $resource);

        return $resources;

    }

    public function getActuals($Year)
    {

        $resources = array();

        foreach($this->workpackages as $workpackage)
            foreach($workpackage->getActuals($Year) as $resource)
                array_push($resources, $resource);

        foreach($this->tasks as $task)
            foreach($task->getActuals($Year) as $resource)
                array_push($resources, $resource);

        return $resources;

    }

}
