<?php

/**
 * This file is part of the ATE Tool - STRAP addon
 *
 * Copyright (c) 2009, 2013 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package models
 */

/**
 * STRAP TechnologyRoadmapDomain object.
 *
 * @author Jiri Pirochta <jiri.pirochta@honeywell.com>
 */
class TechnologyRoadmapDomain extends Object
{
	/** @var string */
	private $domain;
	
	public function __construct()
	{
	}
	
    /** 
     * Sets domain. 
     *  
     * @param string $domain  
     */ 
    public function setDomain($domain) 
    { 
		if(!is_null($domain))
			$this->domain = $domain . ""; 
		else
			throw new InvalidArgumentException('STRAP TechnologyRoadmap Domain cant be null. Wrong param: '.$domain);
    } 

    /** 
     * Gets domain. 
     *  
     * @return string 
     */ 
    public function getDomain() 
    { 
        return $this->domain; 
    } 
}
