<?php

/**
 * This file is part of the ATE Tool
 *
 * Copyright (c) 2009, 2012 Honeywell International spol. s r.o.
 *
 * For the full copyright and license information, please view
 * the file license.txt that was distributed with this source code.
 * @package utils\Logging
 */

/**
 * IFileLogger is is generic inteface to file output logging.
 * 
 * @author Martin Kotlar <martin.kotlar@honeywell.com>
 */
interface IFileLogger extends ILogger
{
	
	/**
	 * Starts logfile.
	 * 
	 * @param string $title Log title.
	 * @return boolean Returns TRUE if logfile was crated/opened successfully.
	 */
    public function open($title = NULL);
	
	/**
	 * Ends logging.
	 */
    public function close();
	
    /**
     * Gets logfilePath.
     * 
     * @return string
     */
    public function getLogfilePath();

	
}


