/**
 * Initialization
 */

/* AJAX form sending */
function ajaxSubmit(event){
	//event.preventDefault();
	$(this).closest('form').ajaxSubmit();
	//return false;
};

/* ajax link */
$(document).on('click', 'a.ajax', function(event) {
	event.preventDefault();
	$.get(this.href);
});

/*Add condition to AJAX loaded content for workableHours*/
function whRefresh()
{
	if($(".isAop").attr("value")==1)
	{
		$(".workableHoursCheckBox").prop("checked", true);
	}
	if($(".workableHoursCheckBox").attr("checked")=="checked")
	{
		$(".workableHoursInputText").prop("disabled", true);
		if(($("#yield").val() == 100) && ($("#contract").val() == 100))
			$('#frmworkableHourForm-Remark').prop("disabled", true);
		else
			$('#frmworkableHourForm-Remark').prop("disabled", false);
	}
	else
	{
		$("#contract").prop("disabled", true);
		$("#yield").prop("disabled", true);
	}                
}

/* AJAX form behavior */
var delay = (function(){
  var timer = 0;
  return function(callback, ms){
    clearTimeout (timer);
    timer = setTimeout(callback, ms);
  };
})();
$("form.ajax input:not(.autocomplete)").live('change keyup', function() {
	var form = $(this).closest('form');
    delay(function(){form.ajaxSubmit();}, 600);
});
$("form.ajax select:not([id*=OrganizationUnitSelector-])").live("change", ajaxSubmit);
// refresh after ajax
$(document).ajaxStop(function(){
	whRefresh();
});

$(document).ready(function ()
{
	/* class clickToExpand/clickToContract look&fell */
	var imageRight = $('<img />');
		imageRight.attr('src', "images/right.gif");
	$(".clickToExpand").prepend(' ').prepend(imageRight);
	var imageDown = $('<img />');
		imageDown.attr('src', "images/down.gif");
	$(".clickToContract").prepend(' ').prepend(imageDown);

	/* ajax filter form */
	$('form.ajax').ajaxSubmit();

	/* ajax autocomplete input */
	$("form input.autocomplete").autocomplete($('.link-autocomplete').text(), {
		parse: function(payload) {
			parsed_data = [];
			for(i = 0; i < payload.autoComplete.length; i++)
			{
				obj = payload.autoComplete[i];
				parsed_data[i] = {
					data: obj,
					value: obj[0],
					result: obj[1],
					result2: obj[2]
				};
			}
			return parsed_data;
		},
		mustMatch: true,
		width: 235,
		delay: 1000,
		callback: function(data, inputId) {
			value = data ? data['value'] : '';
			result = data ? data['result'] : '';
			result2 = data ? data['result2'] : '';
			// regular input (so it's there asap)
			$("#" + inputId).val(result);
			// _info input
			$("#" + inputId + "_info").val(result2);
			// ajaxSubmit
			if($("#" + inputId).closest('form').hasClass('ajax'))
			{
				$("#" + inputId).closest('form').ajaxSubmit();
			}
		}
	});

	/* jquery datepicker input */
	$( "input.datepicker" ).datepicker({
		dateFormat: 'yy-mm-dd'
	});

	whRefresh();

	/* pressing enter return false */
	$('form:not(#frm-loginForm)').keypress(function(e) {
		if(e.which == 13) {
			return false;
		}
	});

});

/* table cell highlights the row */
$("td.rowLink").live('mouseover mouseout', function(){
	$(this).closest('tBody').children('tr:first').children('td:not(:last)').toggleClass('rowLinkActive');
});

/* Nette ajax */
$(function () {
	$.nette.init();
});

/* Fancybox */
$(document).ready(function() {
	$(".fancybox").fancybox();
});

/* Options for displaying qTip */
var qtip_options = {
    // Attribute title
	title: {
		content: {
            attr: 'title'
        },
        position: {
            my: 'bottom left',
            at: 'center left',
            adjust: {
            	y: -5
            }
        },
        style: {
            classes: 'qtip-light'
        },
        hide: {
            fixed: true,
            delay: 300
        }
	},
	// Attribute data-form-tooltip
	formtooltip: {
		content: {
            attr: 'data-form-tooltip',
            title: ''
        },
        position: {
            my: 'bottom left',
            at: 'center left',
            adjust: {
            	y: -5
            }
        },
        style: {
            classes: 'qtip-light'
        },
        hide: {
            fixed: true,
            delay: 300
        }
	}
};

/**
 * Adds tooltips to selected elements
 */
function addTooltips()
{
	// Form tooltips
    $('[data-form-tooltip!=""]').each(function () {
    	qtip_options.formtooltip.content.title = $(this).text();
    	$(this).qtip(qtip_options.formtooltip);
    });
	// Form button tooltips
	$('.button').each(function () 
	{
		if($(this).attr('data-form-button-tooltip'))
		{
			$(this).after("<span class='addtooltipright' style='display: inline-block;' title='" + $(this).attr('data-form-button-tooltip') + "'>&nbsp;</span>");
		}
    });
    // Title tooltips
	/** Disable title tooltips becouse of IE8 */
	//$('[title!=""]').qtip(qtip_options.title);
}

/* qTip basic trigger */
$(document).ready(function() {
    addTooltips();
});

/** TEMPORARY FIX FOR IE BROWSER */
/* qTip trigger for ajax */
// $(document).ajaxStop(function() {
// 	addTooltips();
// });

/* Mandatory form fields */
$(document).ready(function () {
	$('label > span[data-form-tooltip!=""]').addClass('addtooltipright');
});

/* Mandatory form fields */
$(document).ready(function () {
	var label = $("form .required");
    var tooltip = label.find('span[data-form-tooltip!=""]');

    if (tooltip.length)
        tooltip.append(' *');
    else
    	label.append(' *');	
});
